#!/usr/bin/env python
#-*- coding: utf-8 -*-
#=========================
# Filename:  lamp_application_manager_util.py
# Author: Rodrigo J. S. Peixoto
# Date: 2008-08-12
#--------------------------------------------------
# Description:
# It's responsible for the application management.
#--------------------------------------------------
# License:
#
#==================================================

from lamp_utils.lamp_built_in_functions import *
import lamp_application_switcher as las
from subprocess import PIPE
from xml.dom import minidom
import os
import os
import subprocess
import sys
import time

global LAMPEJO_CORE_PATH
LAMPEJO_CORE_PATH=os.getenv("LAMPEJO_CORE_PATH")
if LAMPEJO_CORE_PATH: 
    sys.path.append(LAMPEJO_CORE_PATH)
else:
    raise SystemExit("Error, the environment variable LAMPEJO_CORE_PATH is not defined.")

las.required("wmctrl")

class LampApplication(object):
    '''This class represents an application which has all necessary data to
    create and manipulate the application.

    Tests:
    >>> import lamp_application_manager
    '''

    def __init__(self, app_alias,window_title="", exec_path="", exec_flags="", 
                 remote_control_image="", remote_control_code=0, replaceable=True, file_source=None):
        '''This is the LampApplication constructor.

        Arguments:

            app_alias -- Application alias, it must exists! Ex.: "firefox"
            exec_path -- Path to executable (defaul ""); Ex.: "/usr/bin/firefox"
            exec_flags -- Flags used in the application call  (defaul "");
                Ex.: "-x -l -m -otest"
            replaceable -- It means that the if there is a program running it will be
                just modified or reopened  (defaul False); True - modify; False - reopen
            remote_control_image -- Specify the remote control's image path. This image
                will be sent to the control while the application is running (defaul "");
                Ex.: "/opt/lampejo/images/firefox.png"
            pid --  The process id generated by the Operating System (OS) (defaul -1);

        Exceptions raised:

            - Raise AtributeError if app_alias is not passed

        Tests:
            lamp_unittests.application_manager_test.py
        '''
        assert app_alias, AttributeError("app_alias is not valid, check it out!")
        self._app_alias = app_alias
        self._window_title = window_title
        self._exec_path = exec_path
        tmp = []
        if exec_flags:
            assert check_types({exec_flags: unicode}),\
                'Type Error! app_alias="%s" is not a unicode string' % str(exec_flags)
            tmp = exec_flags.strip().split()
        
        self._exec_flags = tmp
        self._replaceable = replaceable
        self._file_source = file_source
        self._remote_control_image = remote_control_image
        self._remote_control_code = remote_control_code
        self._process = None
        self._pid = None

    def __repr__(self):
        return """
        =================================
        Application: %(app_alias)s
        ---------------------------------
        Window title: %(window_title)s
        Exec path: %(exec_path)s
        Exec flags: %(exec_flags)s
        replaceable: %(replaceable)s 
        Control Image: %(image)s
        Control code: %(Ccode)s
        Pid: %(pid)s      
        """ % {"app_alias": self._app_alias, 
               "window_title": self._window_title,
               "exec_path": self._exec_path, 
               "exec_flags": self._exec_flags,
               "replaceable": self._replaceable, 
               "image": self._remote_control_image,
               "Ccode": self._remote_control_code, 
               "pid": self._pid}
    
    def __eq__(self, app):
        ret = False
        if app:
            ret = (self._app_alias == app._app_alias)
        return ret
    
    def execute_itself(self):
        '''Execute the application that self represents.
        It sets the self.__pid value to the generate OS value to this process.

        Exceptions raised:
            - OSError trying to execute a non-existent file
            - ValueError will be raised if Popen is called with invalid arguments
            - AttributeError if the argumtent types are not correct

        Tests:
            found in lamp_unittests.application_manager_test.py
        '''
        cmd = self._exec_path or self._app_alias
        try:
            self._process = subprocess.Popen([cmd] + \
                                                 self._exec_flags + \
                                                 (self._file_source and [self._file_source] or []), 
                                                 stdout=PIPE, 
                                                 stderr=PIPE, 
                                                 stdin=PIPE)
            self._pid = self._process.pid
        except OSError, e:
            print "DEBUG: open application error: %s" % cmd, e
        
    def kill_itself(self):
        '''
        Kill the application that self represent, the process id will be used by the
        OS to terminate the application

        Exceptions raised:
            
            - OSError if the process id (_pid) is not a real process
            - ValueError if the _pid be less or equal zero

        Tests:
            found in lamp_unittests.application_manager_test.py
        '''
        if self._pid:
            """Trying to close the application, three times..."""
            
            for chance in range(5):
                if chance < 3:
                    las.close_application_gracefully(self._window_title)
                    #subprocess.Popen(["pkill", self._app_alias])
                elif chance == 3:
                    #las.close_application_gracefully(self._window_title)
                    subprocess.Popen(["pkill", self._app_alias])
                else:
                    try:
                        os.kill(self._pid, 9)
                    except OSError:
                        pass
                if self._process and self._process.poll() != None:
                    res = subprocess.Popen("pgrep %s" % self._app_alias,
                                           shell=True,
                                           stdout=subprocess.PIPE).stdout.read()
                    if not res:
                        print "DEBUG: Pid killing proc %d using effort level %d" % (self._pid, chance)
                        break
                time.sleep(0.2)
        else:
            raise ValueError("Process' pid is not valid!")
            
    def is_replaceable(self):
        '''It verifies if the the application is replaceable
        '''
        return self._replaceable

class LampMalFormedXMLError(ValueError):
    '''Raised when config XML is malformed, e.g. there are one or more description
    errors..
    '''
    pass

class LoadConfigApplications:
    '''Class reponsable to load information about the available applications
    from the XML file defined by the user. 
    '''
    def __init__(self, path_to_cfg_file=os.path.join(LAMPEJO_CORE_PATH,'config','lampejo.cfg')):
        self.xmldoc = minidom.parse(path_to_cfg_file)
        self.applications = self.xmldoc.childNodes[0]
    
    def filter_element_nodes(self, elems):
        '''Filter of node elements. All childNodes by the minidom can be 
        a TextNode, ElementNode, CommentNode... We just want the ELEMENT_NODE.
        So this filter return a element list of node elements only.
        
        Arguments:            
            elems -- XML elements by the minidom
        
        Tests:        
            nop
        '''
        return filter(lambda x: x.nodeType == x.ELEMENT_NODE, elems)
    
    def visit_tag(self, elem, action, lamp_application_obj):
        '''It visit all elements in the elem.childNodes executing the proper 
        action
        
        Arguments:
            elem -- ElementNode
            action -- a dictionary where the key is the name of tag and the 
                value is the action that should be executed to this tag, a
                method's reference.
                Ex.:
                    action = {"command": self.get_commands,
                              "remote_control": self.get_remote_control}

        Tests:
            nop
        '''
        for tag in self.filter_element_nodes(elem.childNodes):
            tag_name = tag.nodeName
            try:
                action[tag_name](tag, lamp_application_obj)
            except KeyError, e:
                raise LampMalFormedXMLError('XML error, the tag "%s" is invalid!' % tag_name)
                break
    
    def get_available_applications(self):
        '''Responsible to generate de list with the available applications, 
        based on lampejo.cfg (XML file). All tags app are converted in 
        LampApplication objects.
        
        Return:
            A list with LampApplications available to run for the Lampejo
            
        Tests:
            nop
        '''
        available_applications = []
        action = {"command": self.get_commands, 
                  "remote_control": self.get_remote_control}
        for app in self.filter_element_nodes(self.applications.childNodes):
            lamp_app_id = app.getAttribute("id")
            lamp_app_replaceable = app.getAttribute("replaceable")
            lamp_app_w_title = app.getAttribute("title")
            if not (lamp_app_id and lamp_app_replaceable and lamp_app_w_title):
                msg = 'XML error, the tag "%s" is invalid!' % app.nodeName
                raise LampMalFormedXMLError(msg)
            lamp_obj = LampApplication(lamp_app_id)
            lamp_obj._replaceable = int(lamp_app_replaceable)
            lamp_obj._window_title = lamp_app_w_title
            self.visit_tag(app, action, lamp_obj)
            available_applications.append(lamp_obj)
        return available_applications
                
    def get_commands(self, commands, lamp_application_obj):
        '''Visit method at the commands tag'''
        
        action = {"exec_path": self.get_exec_path, 
                  "exec_flags": self.get_exec_flags}
        self.visit_tag(commands, action, lamp_application_obj)
        
    def get_remote_control(self, remote_control, lamp_application_obj):
        '''Visit method at the remote_control tag'''
        
        action = {"image": self.get_remote_control_image,
                  "code": self.get_remote_control_code,
                  "button1": lambda x, y: None, 
                  "button2": lambda x, y: None, 
                  "button3": lambda x, y: None, 
                  "button4": lambda x, y: None}
        self.visit_tag(remote_control, action, lamp_application_obj)
        
    def get_exec_path(self, exec_path, lamp_application_obj):
        '''Visit method at the exec_path tag'''
        if exec_path.firstChild:
            lamp_application_obj._exec_path = exec_path.firstChild.data
        
    def get_exec_flags(self, exec_flags, lamp_application_obj):
        '''Visit method at the exec_flags tag'''
        if exec_flags.firstChild:
            data = exec_flags.firstChild.data
            if check_types({data: unicode}):
                lamp_application_obj._exec_flags = data.strip().split()
        
    def get_remote_control_image(self, image, lamp_application_obj):
        '''Visit method at the remote_control -> image tag'''
        if image.firstChild:
            lamp_application_obj._remote_control_image = image.firstChild.data
    
    def get_remote_control_code(self, code, lamp_application_obj):
        '''Visit method at the remote_control -> image tag'''
        if code.firstChild:
            lamp_application_obj._remote_control_code = int(code.firstChild.data)

if __name__ == '__main__':
    l = LoadConfigApplications("../config/lampejo.cfg")
    print l.get_available_applications()